{
   MainForm - Orao emulator - glavna forma

   Copyright (C) 2006 Josip Peruanec <josip.perusanec@foing.hr>

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
}

unit MainForm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, MF6502, MMSystem, IniFiles, StdCtrls,
  ComCtrls, Gauges;

type
  TfrmMain = class(TForm)
    Panel1: TPanel;
    pnlStatus: TPanel;
    sbRun: TSpeedButton;
    sbStop: TSpeedButton;
    sbLoad: TSpeedButton;
    sbSave: TSpeedButton;
    sbReset: TSpeedButton;
    sbAbout: TSpeedButton;
    sbSetup: TSpeedButton;
    sbClose: TSpeedButton;
    sbTape: TSpeedButton;
    Panel3: TPanel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Bevel5: TBevel;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    procedure FormCreate(Sender: TObject);
    procedure sbRunClick(Sender: TObject);
    procedure sbStopClick(Sender: TObject);
    function cpuLoop : byte;
    procedure sbCloseClick(Sender: TObject);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sbSaveClick(Sender: TObject);
    procedure sbLoadClick(Sender: TObject);
    procedure sbResetClick(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure sbAboutClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure sbSetupClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure sbTapeClick(Sender: TObject);
  private
    { Private declarations }
    INT_TYPE: Byte;
    DMPFile: file of Byte;
    Postavke: TIniFile;
    Bitmap: TBitmap;
    nTop: integer;
    nLeft: integer;
    procedure DrawScreen;
    function KBDScan(Addr: word): Byte;
    procedure LoadROM;
    procedure UcitajPostavke;
    procedure SpremiPostavke;
    procedure PostaviEkran;
    procedure AddWave;
    procedure PlayWave;
    procedure WaveOne;
    procedure WaveZero;
    function InitWaveOut: boolean;
    procedure CloseWaveOut;
  public
    { Public declarations }
    DumpFrom: integer;
    Verzija: string;
    cpu: M6502;
    TapeName: string;
    Tape: array[0..1048575] of Byte;
    TapePok: integer;
    Mem: array[0..$FFFF] of Byte;
    AktivniROM: integer;
    Ime: array[1..5] of string;
    BAS: array[1..5] of string;
    CRT: array[1..5] of string;
    DoubleSize: integer;
    uspori: integer;
    TapeSnd: integer;
    FastTape: integer;
    function MemoryReadOpcode(Addr : word) : byte;
    function MemoryReadByte(Addr : word) : byte;
    procedure MemoryWrite (Addr : word; value : byte);
  end;

type
	TVirtaulKeyMap = array [Byte] of Boolean;

const
  KbdPorts: array[0..19] of Word = (
    $87FC,$87FD,$87FA,$87FB,$87F6,$87F7,
    $87EE,$87EF,$87DE,$87DF,$87BE,$87BF,
    $877E,$877F,$86FE,$86FF,$85FE,$85FF,
    $83FE,$83FF);

  WBNUM  = 14;
  WFREQ  = 22050;
  WBSIZE = 355;

var
  frmMain: TfrmMain;
  ARect: TRect;
  Beeper: byte;
  BeeperStart: integer;
  BeeperEnd: integer;
  Rev: array[0..255] of byte;
  Bit: byte;
  cntZ: byte;
  cntO: byte;
	VKMap: TVirtaulKeyMap;
  TmpUspori: integer;
  TimeStart,TimeEnd: DWORD;
  BufNum: integer;
  hwo : integer;
  hMem: array[0..WBNUM+1] of HGLOBAL;
  pMem: array[0..WBNUM+1] of Pointer;
  WaveFmt: TWAVEFORMATEX;
  WaveHdr: array[0..WBNUM+1] of TWAVEHDR;
  WaveBuf: array[0..48000] of Byte;
  WavePtr: integer;

implementation

uses AboutForm, SetupForm, KazetaForm, DumpForm;

{$R *.dfm}

procedure TfrmMain.FormCreate(Sender: TObject);
var
  i: integer;
begin
  DumpFrom:=0;
  DoubleBuffered:=True;
  Verzija:='1.34';
  TapePok:=0;
  Bit:=1;
  cntZ:=0;
  cntO:=0;
  frmMain.Caption:='Orao emulator - verzija ' + Verzija;
  TapeName:='';
  for i:=0 to $FFFF do Mem[i]:=$FF;
  Bitmap := TBitmap.Create;
  Bitmap.Width:=256;
  Bitmap.Height:=256;
  Bitmap.PixelFormat:=pf1bit;
  ARect.Left:=10;
  ARect.Top:=40;
  ARect.Right:=522;
  ARect.Bottom:=552;
  for i:= 0 to 255 do begin
    Rev[i]:=0;
    if i and 1 = 1 then Rev[i]:=Rev[i]+128;
    if i and 2 = 2 then Rev[i]:=Rev[i]+64;
    if i and 4 = 4 then Rev[i]:=Rev[i]+32;
    if i and 8 = 8 then Rev[i]:=Rev[i]+16;
    if i and 16 = 16 then Rev[i]:=Rev[i]+8;
    if i and 32 = 32 then Rev[i]:=Rev[i]+4;
    if i and 64 = 64 then Rev[i]:=Rev[i]+2;
    if i and 128 = 128 then Rev[i]:=Rev[i]+1;
  end;
  with cpu do
  begin
    A := 0;
    P := 0;
    X := 0;
    Y := 0;
    S := 0;
    PC.W  := 0;
    iPeriod  := 20000;
    ICount   := 0;
    IRequest := 0;
    AfterCLI := 0;
    IBackup  := 0;
    //void *User;
    TrapBadOps := 0;
    Trap  := 0;
    Trace := 0;
  end;
  UcitajPostavke;
  PostaviEkran;
  LoadROM;
  INT_TYPE:=INT_QUIT;
end;

function TfrmMain.MemoryReadByte(Addr: Word): Byte;
var
  i: integer;
begin
  if Addr=$87FF then begin // tape port
    if cntZ>0 then begin
      Dec(CntZ);
      Result:=0;
      exit;
    end else if cntO>0 then begin
      Dec(cntO);
      Result:=255;
      exit;
    end;
    Result:=0;
    if (FastTape=1) then uspori:=0;
    if TapePok>0 then begin
      if (Tape[TapePok] and Bit) > 0 then begin
        if (TapeSnd>0) and (FastTape=0) then WaveOne;
        CntZ:=$30;
        CntO:=$30;
      end else begin
        if (TapeSnd>0) and (FastTape=0) then WaveZero;
        CntZ:=$17;
        CntO:=$17;
      end;
      Bit:=Bit shl 1;
      if (Bit=0) or (Bit>128) then begin
        Bit:=1;
        Inc(TapePok);
      end;
    end;
    exit;
  end;
  i:=0;
  while i<20 do begin
    if Addr=KbdPorts[i] then begin
      Result:=KBDScan(Addr);
      exit;
    end else begin
      Inc(i);
    end;
  end;
  Result:=Mem[Addr];
end;

procedure TfrmMain.MemoryWrite(Addr: Word; value: Byte);
begin
  if Addr > $A7FF then begin
//  ShowMessage('Pokuaj pisanja u ROM');
  end else if Addr = $8800 then begin // Zvuk
    AddWave;
    Beeper:=Beeper xor 255;
  end else begin
    Mem[Addr]:=value;
  end;
end;

function TfrmMain.MemoryReadOpcode(Addr: Word): Byte;
begin
  Result:=Mem[Addr];
end;

function TfrmMain.cpuLoop : byte;
begin

  if (uspori=1) then
    PlayWave;
  DrawScreen;

  if (uspori=1) then begin
    TimeEnd:=timeGetTime;
    if (TimeEnd-TimeStart<15) then
      Sleep(15-(TimeEnd-TimeStart));
  end;

  uspori:=TmpUspori;
  Application.ProcessMessages;
  TimeStart:=timeGetTime;
  Result:=INT_TYPE;
end;

function TfrmMain.KBDScan(Addr: word): byte;
var
  D7,D6,D5,D4: byte;
begin
  D7:=1;  // bitovi na izlazu 74LS257
  D6:=1;
  D5:=1;
  D4:=1;
  case Addr of
    $87FC:begin // A1,ulazi A
      if VKMap[VK_LEFT]  then D4:=0;
      if VKMap[VK_UP]    then D5:=0;
      if VKMap[VK_DOWN]  then D6:=0;
      if VKMap[VK_RIGHT] then D7:=0;
    end;
    $87FD:begin // A1, ulazi B
      if VKMap[VK_RETURN]  then D4:=0;
      if VKMap[VK_CONTROL] then D5:=0;
    end;
    $87FA:begin // A2, ulazi A
      if VKMap[VK_F1] then D4:=0;
      if VKMap[VK_F2] then D5:=0;
      if VKMap[VK_F3] then D6:=0;
      if VKMap[VK_F4] then D7:=0;
    end;
    $87FB:begin // A2, ulazi B
      if VKMap[VK_SPACE] then D4:=0;
      if VKMap[VK_SHIFT] then D5:=0;
    end;
    $87F6:begin // A3, ulazi A
      if VKMap[Ord('R')] then D4:=0;
      if VKMap[Ord('Z')] then D5:=0;
      if VKMap[Ord('T')] then D6:=0;
      if VKMap[Ord('6')] then D7:=0;
    end;
    $87F7:begin // A3, ulazi B
      if VKMap[Ord('5')] then D4:=0;
      if VKMap[Ord('4')] then D5:=0;
    end;
    $87EE:begin // A4, ulazi A
      if VKMap[Ord('O')] then D4:=0;
      if VKMap[Ord('I')] then D5:=0;
      if VKMap[Ord('U')] then D6:=0;
      if VKMap[Ord('7')] then D7:=0;
    end;
    $87EF:begin // A4, ulazi B
      if VKMap[Ord('8')] then D4:=0;
      if VKMap[Ord('9')] then D5:=0;
    end;
    $87DE:begin // A5, ulazi A
      if VKMap[Ord('E')] then D4:=0;
      if VKMap[Ord('Q')] then D5:=0;
      if VKMap[Ord('W')] then D6:=0;
      if VKMap[Ord('1')] then D7:=0;
    end;
    $87DF:begin // A5, ulazi B
      if VKMap[Ord('2')] then D4:=0;
      if VKMap[Ord('3')] then D5:=0;
    end;
    $87BE:begin // A6, ulazi A
      if VKMap[Ord('L')] then D4:=0;
      if VKMap[Ord('J')] then D5:=0;
      if VKMap[Ord('K')] then D6:=0;
      if VKMap[Ord('M')] then D7:=0;
    end;
    $87BF:begin // A6, ulazi B
      if VKMap[$BC] then D4:=0; // ,
      if VKMap[$BE] then D5:=0; // .
    end;
    $877E:begin // A7, ulazi A
      if VKMap[Ord('D')] then D4:=0;
      if VKMap[Ord('A')] then D5:=0;
      if VKMap[Ord('S')] then D6:=0;
      if VKMap[Ord('Y')] then D7:=0;
    end;
    $877F:begin // A7, ulazi B
      if VKMap[Ord('X')] then D4:=0;
      if VKMap[Ord('C')] then D5:=0;
    end;
    $86FE:begin // A8, ulazi A
      if VKMap[Ord('F')] then D4:=0;
      if VKMap[Ord('H')] then D5:=0;
      if VKMap[Ord('G')] then D6:=0;
      if VKMap[Ord('N')] then D7:=0;
    end;
    $86FF:begin // A8, ulazi B
      if VKMap[Ord('B')] then D4:=0;
      if VKMap[Ord('V')] then D5:=0;
    end;
    $85FE:begin // A9, ulazi A
      if VKMap[$BA] then D4:=0; // 
      if VKMap[$DE] then D5:=0; // 
      if VKMap[$DC] then D6:=0; // 
      if VKMap[$BB] then D7:=0; // :
    end;
    $85FF:begin // A9, ulazi B
      if VKMap[VK_BACK] then D4:=0; // /
      if VKMap[$C0]     then D5:=0; // ^
    end;
    $83FE:begin // A10, ulazi A
      if VKMap[Ord('P')] then D4:=0;
      if VKMap[$DD]      then D5:=0; // 
      if VKMap[$DB]      then D6:=0; // 
      if VKMap[$BF]      then D7:=0; // ;
    end;
    $83FF:begin // A10, ulazi B
      if VKMap[$BD]      then D4:=0; // -
      if VKMap[Ord('0')] then D5:=0;
    end;
  end;
  Result:=$00+D7*128+D6*64+D5*32+D4*16;
end;

procedure TfrmMain.sbRunClick(Sender: TObject);
var
  i: integer;
begin
  if InitWaveOut then begin
    for i := 1 To 12 do
      waveOutWrite(hwo,@WaveHdr[i],sizeof(WAVEHDR));
    BufNum := 12;
  end;
  INT_TYPE:=INT_NONE;
  sbRun.Visible:=False;
  sbStop.Visible:=True;
  sbClose.Enabled:=False;
  sbSetup.Enabled:=False;
  sbLoad.Enabled:=True;
  sbSave.Enabled:=True;
  sbReset.Enabled:=True;
  sbTape.Enabled:=True;
  Reset6502(cpu);
  Beeper:=0;
  BeeperStart:=cpu.IPeriod;
  BeeperEnd:=0;
  TimeStart:=GetTickCount;
  Run6502(cpu);
end;

procedure TfrmMain.sbStopClick(Sender: TObject);
var
  i: integer;
begin
  CloseWaveOut;
  INT_TYPE:=INT_QUIT;
  sbRun.Visible:=True;
  sbStop.Visible:=False;
  sbClose.Enabled:=True;
  sbSetup.Enabled:=True;
  sbLoad.Enabled:=False;
  sbSave.Enabled:=False;
  sbReset.Enabled:=False;
  sbTape.Enabled:=False;
  pnlStatus.Caption:='';
  for i:=$6000 to $7FFF do Mem[i]:=0;
  DrawScreen;
end;

procedure TfrmMain.sbCloseClick(Sender: TObject);
begin
  frmMain.Close;
end;

procedure TfrmMain.DrawScreen;
var
  x: integer;
  y: integer;
  k: integer;
  Row: pByteArray;
begin
  with Bitmap do begin
    k:=$6000;
    for y:= 0 to 255 do begin
      Row := pByteArray(Scanline[y]);
      for x:=0 to 31 do begin
        Row[x] := Rev[Mem[k]];
        Inc(k);
      end;
    end;
  end;
  if not (DoubleSize=1) then
    frmMain.Canvas.Draw(10,40,Bitmap)
  else
    frmMain.Canvas.StretchDraw(ARect,Bitmap);
end;

procedure TfrmMain.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  VKMap[Key] := False;
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key in [VK_F12]) then frmDump.Show;
  if (Key in [VK_F10]) then begin
    Bitmap.SaveToFile(ExtractFilePath(
      Application.ExeName)+'capture.bmp');
  end;
  VKMap[Key] := True;
end;

procedure TfrmMain.sbSaveClick(Sender: TObject);
begin
  SaveDialog1.InitialDir:=ExtractFileDir(ParamStr(0));
  if (SaveDialog1.Execute) then begin
    AssignFile(DMPFile,SaveDialog1.FileName);
    Rewrite(DMPFile);
    BlockWrite(DMPFile,cpu,sizeof(cpu));
    BlockWrite(DMPFile,Mem,$8000);
    CloseFile(DMPFile);
  end;
end;

procedure TfrmMain.sbLoadClick(Sender: TObject);
var
  pom: integer;
begin
  pom:=cpu.IPeriod;
  OpenDialog1.DefaultExt:='dmp';
  OpenDialog1.Filter:='Dmp datoteke (*.dmp)|*.dmp';
  OpenDialog1.FilterIndex:=1;
  OpenDialog1.InitialDir:=ExtractFileDir(ParamStr(0));
  if (OpenDialog1.Execute) then begin
    AssignFile(DMPFile,OpenDialog1.FileName);
    Reset(DMPFile);
    BlockRead(DMPFile,cpu,sizeof(cpu));
    BlockRead(DMPFile,Mem,$8000);
    cpu.IPeriod:=pom;
    CloseFile(DMPFile);
  end;
end;

procedure TfrmMain.sbResetClick(Sender: TObject);
begin
  INT_TYPE:=INT_QUIT;
  Application.ProcessMessages;
  Sleep(1000);
  INT_TYPE:=INT_NONE;
  Reset6502(cpu);
end;

procedure TfrmMain.FormPaint(Sender: TObject);
begin
  ControlStyle:=ControlStyle+[csOpaque];
end;

procedure TfrmMain.sbAboutClick(Sender: TObject);
begin
  frmAbout.ShowModal;
end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Bitmap.Free;
  SpremiPostavke;
end;

procedure TfrmMain.sbSetupClick(Sender: TObject);
begin
  frmSetup.ShowModal;
  if frmSetup.ModalResult=mrOK then begin
    LoadROM;
    PostaviEkran;
  end;
end;

procedure TfrmMain.LoadROM;
var
  f: File of Byte;
  i: integer;
begin
  for i:=0 to $FFFF do Mem[i]:=$FF;
  AssignFile(f,ExtractFilePath(Application.EXEName)+
    BAS[AktivniROM]);
  Reset(f);
  for i:=$C000 to $DFFF do Read(f,Mem[i]);
  CloseFile(f);
  AssignFile(f,ExtractFilePath(Application.EXEName)+
    CRT[AktivniROM]);
  Reset(f);
  for i:=$E000 to $FFFF do Read(f,Mem[i]);
  CloseFile(f);
end;

procedure TfrmMain.UcitajPostavke;
var
  i: integer;
  f: TextFile;
  tf: File of Byte;
begin
  if not FileExists('OraoEmulator.ini') then begin
    AssignFile(f,ExtractFilePath(
      Application.EXEName)+'OraoEmulator.ini');
    Rewrite(f);
    Writeln(f,'[rom]');
    Writeln(f,'aktivni=2');
    Writeln(f,'opis1=verzija 102');
    Writeln(f,'crt1=crt12.rom');
    Writeln(f,'bas1=bas12.rom');
    Writeln(f,'opis2=verzija 103');
    Writeln(f,'crt2=crt13.rom');
    Writeln(f,'bas2=bas13.rom');
    Writeln(f,'opis3=');
    Writeln(f,'crt3=');
    Writeln(f,'bas3=');
    Writeln(f,'opis4=');
    Writeln(f,'crt4=');
    Writeln(f,'bas4=');
    Writeln(f,'opis5=');
    Writeln(f,'crt5=');
    Writeln(f,'bas5=');
    Writeln(f,'[ekran]');
    Writeln(f,'x2=0');
    Writeln(f,'xk=1');
    Writeln(f,'yk=1');
    Writeln(f,'[emulacija]');
    Writeln(f,'uspori=1');
    Writeln(f,'[kazeta]');
    Writeln(f,'zvuk=1');
    Writeln(f,'turbo=0');
    Writeln(f,'datoteka=');
    CloseFile(f);
  end;
  Postavke:=TIniFile.Create(ExtractFilePath(
    Application.EXEName)+'oraoemulator.ini');
  AktivniROM:=Postavke.ReadInteger('rom',
    'aktivni',1);
  for i:= 1 to 5 do begin
    Ime[i]:=Postavke.ReadString('rom',
      'opis'+IntToStr(i), ' ');
    BAS[i]:=Postavke.ReadString('rom',
      'bas'+IntToStr(i), ' ');
    CRT[i]:=Postavke.ReadString('rom',
      'crt'+IntToStr(i), ' ');
  end;
  DoubleSize:=Postavke.ReadInteger('ekran','x2',0);
  nLeft:=Postavke.ReadInteger('ekran','xk',1);
  nTop:=Postavke.ReadInteger('ekran','yk',0);
  uspori:=Postavke.ReadInteger('emulacija','uspori',1);
  TmpUspori:=uspori;
  TapeSnd:=Postavke.ReadInteger('kazeta','zvuk',1);
  FastTape:=Postavke.ReadInteger('kazeta','turbo',1);
  TapeName:=Postavke.ReadString('kazeta','datoteka','');
  if TapeName<>'' then begin
    if not FileExists(TapeName) then begin
      TapeName:='';
    end else begin
      TapePok:=360;
      AssignFile(tf,frmMain.TapeName);
      Reset(tf);
      BlockRead(tf,frmMain.Tape,1048575,br);
      CloseFile(tf);
    end;
  end;
  Postavke.Free;
end;

procedure TfrmMain.SpremiPostavke;
begin
  Postavke:=TIniFile.Create(ExtractFilePath(
    Application.EXEName)+'oraoemulator.ini');
  Postavke.WriteInteger('rom','aktivni',AktivniROM);
  Postavke.WriteInteger('ekran','x2',DoubleSize);
  Postavke.WriteInteger('ekran','xk',frmMain.Left);
  Postavke.WriteInteger('ekran','yk',frmMain.Top);
  Postavke.WriteInteger('emulacija','uspori',uspori);
  Postavke.WriteInteger('kazeta','zvuk',TapeSnd);
  Postavke.WriteInteger('kazeta','turbo',FastTape);
  Postavke.WriteString('kazeta','datoteka',TapeName);
  Postavke.Free;
end;

procedure TfrmMain.PostaviEkran;
begin
  frmMain.Top:=nTop;
  frmMain.Left:=nLeft;
  if DoubleSize=1 then begin
    frmMain.Width:=256+284;
    frmMain.Height:=256+371;
  end else begin
    frmMain.Width:=284;
    frmMain.Height:=371;
  end;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if INT_TYPE <> INT_QUIT then
    CanClose := False
  else
    CanClose := True;
end;

procedure TfrmMain.AddWave;
var
  i: integer;
begin
  BeeperEnd:=cpu.ICount;
  for i:= 1 to 1+Trunc((BeeperStart-BeeperEnd)/45) do begin
    WaveBuf[WavePtr]:=Beeper;
    Inc(WavePtr);
  end;
  BeeperStart:=BeeperEnd;
end;

procedure TfrmMain.WaveOne;
var
  i: integer;
begin
  for i:=1 to 18 do begin
    WaveBuf[WavePtr]:=0;
    Inc(WavePtr);
  end;
  for i:=1 to 18 do begin
    WaveBuf[WavePtr]:=240;
    Inc(WavePtr);
  end;
end;

procedure TfrmMain.WaveZero;
var
  i: integer;
begin
  for i:=1 to 9 do begin
    WaveBuf[WavePtr]:=0;
    Inc(WavePtr);
  end;
  for i:=1 to 9 do begin
    WaveBuf[WavePtr]:=240;
    Inc(WavePtr);
  end;
end;

procedure TfrmMain.PlayWave;
var
  i: integer;
  pSrc: Pointer;
  pDst: Pointer;
begin
  Inc(BufNum);
  for i := WavePtr to WBSIZE do
    WaveBuf[i] := WaveBuf[WavePtr - 1];
  pDst := WaveHdr[BufNum].lpData;
  pSrc := @WaveBuf[0];
  CopyMemory(PDst,PSrc,WBSIZE);
  waveOutWrite(hwo,@WaveHdr[BufNum],sizeof(WAVEHDR));
  if BufNum = WBNUM then BufNum := 0;
  WavePtr := 0;
  BeeperStart:=cpu.IPeriod;
end;

procedure TfrmMain.sbTapeClick(Sender: TObject);
begin
  frmKazeta.ShowModal;
end;

procedure TfrmMain.CloseWaveOut;
var
  i: integer;
begin
  waveOutReset(hwo);
  for i := 1 To WBNUM do
    waveOutUnprepareHeader(hwo,@WaveHdr[i],sizeof(WAVEHDR));
  for i := 1 To WBNUM do begin
    GlobalUnlock(hMem[i]);
    GlobalFree(hMem[i]);
  end;
  waveOutClose(hwo);
end;

function TfrmMain.InitWaveOut: boolean;
var
  i: integer;
  l: integer;
  l2: integer;
  sErrMsg: string;
begin
  With WaveFmt do begin
    wFormatTag := WAVE_FORMAT_PCM;
    nChannels := 1;
    nSamplesPerSec := WFREQ;
    nAvgBytesPerSec := WFREQ;
    nBlockAlign := 1;
    wBitsPerSample := 8;
    cbSize := 0;
  end;
  i := waveOutOpen(@hwo,WAVE_MAPPER,@WaveFmt,0,0,CALLBACK_NULL);
  if i <> MMSYSERR_NOERROR then begin
    SetLength(sErrMsg,256);
    waveOutGetErrorText(i,PChar(sErrMsg),255);
    Application.MessageBox(PChar('Error initialising WaveOut device.' + #13#10#13#10 + sErrMsg),
      PChar('Orao emulator'),MB_OK or MB_ICONEXCLAMATION);
    Result := False;
    exit;
  end;
  for l := 0 To WBNUM do begin
    hMem[l] := GlobalAlloc(GPTR, WBSIZE+100);
    pMem[l] := GlobalLock(hMem[l]);
    WaveHdr[l].lpData := pMem[l];
    WaveHdr[l].dwBufferLength := WBSIZE;
    WaveHdr[l].dwUser := 0;
    WaveHdr[l].dwFlags := 0;
    WaveHdr[l].dwLoops := 0;
    WaveHdr[l].lpNext := nil;
    i := waveOutPrepareHeader(hwo,@WaveHdr[l],sizeof(WAVEHDR));
    if i <> MMSYSERR_NOERROR then begin
      SetLength(sErrMsg,256);
      waveOutGetErrorText(i,PChar(sErrMsg),255);
      Application.MessageBox(PChar('Error preparing wave header.' + #13#10#13#10 + sErrMsg),
        PChar('Orao emulator'),MB_OK or MB_ICONEXCLAMATION);
      waveOutClose(hwo);
      for l2 := 0 To WBNUM do begin
        GlobalUnlock(hMem[l2]);
        GlobalFree(hMem[l2]);
      end;
      Result := False;
      exit;
    end;
  end;
  Result := True;
end;

end.

